from dataclasses import dataclass
from typing import Tuple

import pygame

from views.components.ReactTextField import ReactTextField, ReactPropsTextField, ReactStateTextField
from views.events.EventKey import EventKey
from views.react.ReactComponent import ReactComponent, ReactProps, ReactState


@dataclass
class ReactPropsTextBox(ReactPropsTextField):
    color_border: Tuple = (0, 0, 0)
    color_background: Tuple = (255, 255, 255)
    onTextChange: callable = None


@dataclass
class ReactStateTextBox(ReactStateTextField):
    text: str = ""
    onTextChange: callable = None


class ReactTextBox(ReactComponent):
    def __init__(self, props: ReactPropsTextBox):
        super().__init__(props)


    def render(self):
        return [] #TODO

    def onKeyDown(self, event: EventKey):
        #TODO
        pass

    def draw(self, screen):
        #TODO
        super().draw(screen)